/*                                 SOPHOS.C                                */
#include "Sophos.h"

/* *********************************************************************** */
   int filerw(SemaStat *stat, int purpose)
/* *********************************************************************** */
{ /*Datenuebertragung zwischen geoeffneter Datei und Philosophen-Struktur*/
  int  j1=0;
  char dummyc[LENGTH];

  /*READ/WRITE:*/
  if (purpose & WRITE)
  { 
    /*Vorm Ueberschreiben Struktur aktualisieren:*/
    stat->actId = stat->philId;
    fgets(dummyc, LENGTH, stat->sema); fseek (stat->sema, 0L, SEEK_CUR);/*Blockierg s.u.*/
    fprintf(stat->sema,"%*d" ACTID  "\n", WIDTH, stat->actId);  /*letzter Nutzer */
    fprintf(stat->sema,"%*d" PHILNR "\n", WIDTH, stat->philNr); /*Anzahl dinierender Philosophen*/

    for (j1=0; j1<stat->philNr; j1++)
    { fseek (stat->sema, 0L, SEEK_CUR);
      if (j1 == stat->philId || stat->phHung[j1] == INIT) /*Anfangs- o.aktuelle Saettigg*/
        fprintf(stat->sema,"%*d" PHHUNG "\n", WIDTH, stat->phHung[j1], j1, j1);
      else                    /*..oder Zeile ueberspringen:*/
      { 
        fgets(dummyc, LENGTH, stat->sema);
      }
    } 
    fseek (stat->sema, 0L, SEEK_CUR); /* "Selbstverortung" */
    if (stat->closed >= DONE && stat->philNr <= 0) stat->closed = INIT; /*Datei-Vorbereitg fuer naechstes Mal*/
    fprintf(stat->sema,"%*d" CLOSED "\n", WIDTH, stat->closed); /*Schliessung & Kommentar*/
    fflush(stat->sema);  
  } 

  else  /* READ: */

  { fscanf(stat->sema,"%d", &stat->blockCS); /*Blockierung*/
    fgets(dummyc, LENGTH, stat->sema); /*Kommentar*/
    fscanf(stat->sema,"%d", &stat->actId); /*zuletzt aktivierter Philosoph*/
    fgets(dummyc, LENGTH, stat->sema); /*Kommentar*/
    fscanf(stat->sema,"%d", &stat->philNr); /*Anzahl dinierender Philosophen*/
    fgets(dummyc, LENGTH, stat->sema); /*Kommentar*/
    for (j1=0; j1<stat->philNr; j1++)
    { fscanf(stat->sema,"%d", &(stat->phHung[j1])); /*Saettigungszustand Philosoph j1*/
      fgets(dummyc, LENGTH, stat->sema); /*Kommentar*/
    }
    fscanf(stat->sema,"%d", &stat->closed); /*Schliessung*/
    fgets(dummyc, LENGTH, stat->sema); /*Kommentar*/
  }

  return(OK); 
}
/* *********************************************************************** */
   int filio(SemaStat *stat, int purpose)
/* *********************************************************************** */
{ /*Zentrale I/O-Fktn fuer geoeffnete Datei*/
  int  j1=0, dummyi=0, exitFlag=STAY;

  /*Geoeffnete Datei fuer sich reservieren:*/
   freserve(stat);

  /*Hat einer beendet, stimmen Philosophen-Daten u.-Indizes nicht mehr!*/
  if (stat->closed>=DONE) 
  { for (j1=0; j1<stat->philNr; j1++) stat->phHung[j1] = INIT;
    stat->philNr--; 
    freopen(FILPATH, "w+", stat->sema); /*alles neu machen*/
    fprintf(stat->sema,"%*d" BLOCKCS  "\n", WIDTH, LOCKED); /*Blockierg & Kommentar*/
    fflush(stat->sema); 
    exitFlag = EXIT;  purpose = WRITE | RELEASE;
  }
  rewind(stat->sema);  

  /*RW-Auftrag ausfuehren:*/
  filerw(stat, purpose);

  /*Sperrt & entsperrt immer:*/
  rewind(stat->sema);  
  if ((purpose & BLOCK) && stat->closed < DONE) stat->blockCS = LOCKED; 
  else                                          stat->blockCS = UNLOCK;
  fprintf(stat->sema,"%*d" BLOCKCS "\n", WIDTH, stat->blockCS);/*Blockierung & Kommentar*/
  fprintf(stat->sema,"%*d" ACTID   "\n", WIDTH, stat->actId);  /*zuletzt aktivierter Philosoph*/
  fflush(stat->sema); 

  /* Laeuft noch das Diner? */
  if (exitFlag==EXIT) 
  { fclose (stat->sema);  system (CLEAR);
    if (stat->philNr < 1) printf ("[%d] " MINTWO, stat->philId);
    printf ("[%d] " THATSIT, stat->philId); _getch(); exit(OK);
  }
  return(OK); 
}

/* *********************************************************************** */
   void init()
/* *********************************************************************** */
{ SemaStat *stat=common();
  int       j1=0;

  stat->sema    = NULL;
  stat->blockCS = INIT;
  stat->philNr  = INIT; 
  stat->actId   = INIT; 
  stat->closed  = INIT;
  stat->philId  = INIT; 
  for (j1=0; j1<MAXPHIL; j1++) stat->phHung[j1] = INIT;  

  /*Falls Datei existiert:*/
  if ((stat->sema=fopen(FILPATH,"r+"))!=NULL)
  { filio(stat, READ | BLOCK);
    if (stat->philNr > 0) /*Auch andere am Tisch*/
    { if (stat->closed >= SHUT) /*Kein Platz frei*/
      { filio(stat, READ | RELEASE);
        fclose (stat->sema);  system (CLEAR);
        printf (TOOLATE); _getch(); exit (KO);
      } else                    /*Platz frei*/
      { stat->philNr++;         /*(Rest s.u.)*/
      } 
    } else                      /*stat->philNr<=0*/
    { fclose (stat->sema);
      remove(FILPATH); stat->sema = NULL; /* Sicherer: neu erzeugen */
    }
  }

  /*Falls Datei neu: Idx 0!*/
  if (stat->sema == NULL && (stat->sema=fopen(FILPATH,"w+"))!=NULL)
  { stat->philNr = 1; /*(Rest s.u.)*/
  } 
  if (stat->sema == NULL) exit(KO);/*fopen endgueltig fehlgeschlagen*/
    
  stat->philId = stat->philNr-1; 
  stat->phHung[stat->philId] = THINKING; 
  if (stat->philNr >= MAXPHIL) stat->closed = SHUT;
  else                         stat->closed = OPEN;
  filio(stat, WRITE | RELEASE);
  system (CLEAR);  printf ("Ich habe den Index %d!\n", stat->philId); 
  _getch(); system (CLEAR); printf ("[%d] ", stat->philId);
  return;
}
